// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import Injectable from "../../../../core/injectable/Injectable";
import { CommandBus } from "../../../../core/command/CommandBus";
import { QueryBus } from "../../../../core/query/QueryBus";
import { LogError } from "../../../../core/decorator/LogErrorDecorator";
import ValidatedRequest from "../../../../core/validation/ValidatedArgs";
import SetRateRequest from "../../request/interestRates/SetRateRequest";
import GetRateRequest from "../../request/interestRates/GetRateRequest";
import { SetRateCommand } from "../../../../app/usecase/command/interestRates/setRate/SetRateCommand";
import { GetRateQuery } from "../../../../app/usecase/query/interestRates/getRate/GetRateQuery";
class FixedRateInPort {
    commandBus;
    queryBus;
    constructor(commandBus = Injectable.resolve(CommandBus), queryBus = Injectable.resolve(QueryBus)) {
        this.commandBus = commandBus;
        this.queryBus = queryBus;
    }
    async setRate(request) {
        ValidatedRequest.handleValidation("SetRateRequest", request);
        return await this.commandBus.execute(new SetRateCommand(request.securityId, request.rate, request.rateDecimals));
    }
    async getRate(request) {
        ValidatedRequest.handleValidation("GetRateRequest", request);
        const result = await this.queryBus.execute(new GetRateQuery(request.securityId));
        return {
            rate: result.rate.toString(),
            decimals: result.decimals,
        };
    }
}
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [SetRateRequest]),
    __metadata("design:returntype", Promise)
], FixedRateInPort.prototype, "setRate", null);
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [GetRateRequest]),
    __metadata("design:returntype", Promise)
], FixedRateInPort.prototype, "getRate", null);
const FixedRate = new FixedRateInPort();
export default FixedRate;
